package main

import (
	"cicv-data-closedloop/aarch64/plugin-compile/package/config/c_nacos"
	"cicv-data-closedloop/aarch64/plugin-compile/package/config/c_oss"
	"cicv-data-closedloop/aarch64/plugin-compile/package/handler/h_compile_plugin"
	"cicv-data-closedloop/common/config/c_log"
	"cicv-data-closedloop/common/handler/h_validate_request_header"
	"net/http"
	"os"
)

const servicePort = "12340"

func init() {
	// 初始化日志配置
	c_log.InitLog("plugin-compile")
	c_oss.InitOss()
	c_nacos.InitNacos()
}

func main() {
	mux := http.NewServeMux()
	mux.Handle("/compile", h_validate_request_header.HeaderValidationMiddleware(&h_compile_plugin.CompileHandler{}))
	err := http.ListenAndServe(":"+servicePort, mux)
	if err != nil {
		c_log.GlobalLogger.Error("程序崩溃监听端口 " + servicePort + " 失败。")
		os.Exit(-1)
	}
}
